mod graph;
mod mpsc;

use graph::Graph;

fn main() {
    mpsc::run_mpsc();
}

fn run_graph() {
    let mut g = Graph::new(10);
    println!("Grafo g -> {}", g);
    println!("Agrego vertices");
    g.add_vertex(0, 1);
    g.add_vertex(1, 2);
    g.add_vertex(1, 3);
    g.add_vertex(1, 5);
    g.add_vertex(3, 5);
    g.add_vertex(3, 6);
    g.add_vertex(3, 8);
    g.add_vertex(5, 6);
    g.add_vertex(2, 7);
    g.add_vertex(7, 4);
    println!("Grafo g -> {}", g);





    println!("Usando DFS iterator"); 
    for node in g.iter() {
        println!("Node: {:?}", node);
    }

    // Tomar los primeros 3
    println!("Iterando los primeros 3"); 
    for node in g.iter().take(3) {
        println!("Node: {:?}", node);
    }

    // Busco el nodo con id 5 (notar que devuelve Option, ya que puede no existir)
    let pos_5 = g.iter().position(|node| node == 5);
    println!("Buscando el índice del nodo 5: {:?} ", pos_5);
}